<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/

# Check variables
if (!strlen($sort)) $sort= "queuing_time";
if (!strlen($timefrom)) $timefrom= "00:00:00";
if (!strlen($timeto)) $timeto= "23:59:59";
if (!strlen($datefrom))
  $datefrom= date ("d.m.Y",strtotime ("-2 days"));
if (!strlen($dateto))
  $dateto= date ("d.m.Y",strtotime ("now"));
if (!strlen($department)) $department= _("all");
if (!strlen($fuser))
  $fuser= ($isadmin)?_("all"):"$username";

# validate and convert to timestamp
$datetostamp= mktime (substr($timeto,0,2),substr($timeto,3,2),substr($timeto,6,2),substr($dateto,3,2),substr($dateto,0,2),substr($dateto,6,4));
if ($datetostamp == -1) $datetostamp= strtotime("now");
$datefromstamp= mktime (substr($timefrom,0,2),substr($timefrom,3,2),substr($timefrom,6,2),substr($datefrom,3,2),substr($datefrom,0,2),substr($datefrom,6,4));
if ($datefromstamp == -1 ) $datefromstamp= strtotime("-2 days");

# prepare for query and fields
$now= date ("YmdHis",$datetostamp);
$past=date ("YmdHis",$datefromstamp);
$timefrom= date ("H:i:s",$datefromstamp);
$timeto= date ("H:i:s",$datetostamp);
$datefrom= date ("d.m.Y",$datefromstamp);
$dateto= date ("d.m.Y",$datetostamp);

# get list of departments we are responsible for
$deplist= array();
$single_user=false;
if ($isadmin) {
  $dlist= ldap_get_list ("(&(ou=*)(objectClass=isDepartment))");
  $deplist[]= _("all");
  for ($i= 0; $i<$dlist["count"]; $i++)
    for ($j= 0; $j<$dlist[$i]["ou"]["count"]; $j++)
      $deplist[]= $dlist[$i]["ou"][$j];
}
else {
  $dlist= ldap_get_list ("uid=$username");
  for ($i=0; $i<$dlist[0]["departmentname"]["count"]; $i++)
    $deplist[]= $dlist[0]["departmentname"][$i];
  
  if (count ($deplist) == 0) {
    $deplist[]= _("none");
    $single_user= true;
  }
}

## fge alle Mitglieder aus $deplist und evtl. ("alle") in $userlist ein.
$usrlist= array();
$found_user= false;
if (!$single_user){
  $usrlist[]= _("all");
  for ($i= 0; $i<count($deplist); $i++){
    $dep= $deplist[$i];
    if ($dep == _("all")) continue;
    $ulist= ldap_get_list ("(&(objectclass=gonicusAccount)(ou=$dep))");
    for ($j= 0; $j<$ulist["count"]; $j++){
      $usrlist[]= $ulist[$j]["uid"][0];
      if ($ulist[$j]["uid"][0] == $fuser) $found_user= true;
    }
  }
  if (!$found_user) $fuser= _("all");
} else { $usrlist[]="$username"; $fuser= $username; $found_user= true;}


// Connecting, selecting database
$link = mysql_connect($FAX_SERVER, $FAX_LOGIN, $FAX_PASSWORD)
    or die(_("Could not connect to database server!"));
mysql_select_db("gofax")
    or die(_("Could not select database!"));

// Status array
$status= array( "SENT", "MAILED", "SERROR", "RERROR", "SBLOCK", "RBLOCK", "DELETED", "REQUEUED", "DISABLED", "PRINTED", "DIVERTED", "UNDEFINED", "UNDEFINED", "UNDEFINED", "UNDEFINED", "UNDEFINED");

if ($show_details) {
  $decide= $isadmin?1:($found_user==true);
  if ($decide) {
    $fax_id= $show_details;
    session_register ("fax_id");
    $query = "SELECT id,uid,queuing_time,status,sender_id,sender_msn,receiver_id,receiver_msn,pages,status_message,transfer_time FROM faxlog WHERE id = '$fax_id' ORDER BY $sort";
    print ("<h1>"._("FAX detail information")."</h1>\n");
    $result = mysql_query($query) or die(_("Database query failed!"));  

    while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
      $parts= array( "id", "uid", "queuing_time", "status", "sender_id", "sender_msn", "receiver_id", "receiver_msn", "pages", "status_message", "transfer_time" );
      foreach ($parts as $vname) {
        $final="fax_$vname";
        $$final= $line[$vname];
      }
    }
    print ("<table valign=top cellspacing=0 cellpadding=2 width=60% bgcolor=\"#EAEAEA\">\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Fax ID").":</b></td>\n");
    print ("  <td>$fax_id</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("User").":</b></td>\n");
    print ("  <td>$fax_uid</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Date / Time").":</b></td>\n");
    print ("  <td>");
    print (substr($fax_queuing_time,6,2).".".substr($fax_queuing_time,4,2).".".substr($fax_queuing_time,0,4)." / ".substr($fax_queuing_time,8,2).":".substr($fax_queuing_time,10,2).":".substr($fax_queuing_time,12,2));
    print ("</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Sender MSN").":</b></td>\n");
    print ("  <td>$fax_sender_msn</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Sender ID").":</b></td>\n");
    print ("  <td>$fax_sender_id</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Receiver MSN").":</b></td>\n");
    print ("  <td>$fax_receiver_msn</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Receiver ID").":</b></td>\n");
    print ("  <td>$fax_receiver_id</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Status").":</b></td>\n");
    print ("  <td>$status[$fax_status]</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Status message").":</b></td>\n");
    print ("  <td>");
    $temp= strlen($fax_status_message)?$fax_status_message:"NA";
    print ("$temp</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Transfer time (seconds)").":</b></td>\n");
    print ("  <td>");
    $temp= strlen($fax_transfer_time)?"$fax_transfer_time":"NA";
    print ("$temp</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("# Pages").":</b></td>\n");
    print ("  <td>$fax_pages</td>\n");
    print (" </tr>\n");
    print (" <tr>\n");
    print ("  <td><b>"._("Fax").":</b></td>\n");
    if ($fax_pages != 0) {
	print ("  <td><a href=\"include/getfax.inc\">"._("Download file")."</a></td>\n");
    }else{
	print ("  <td>"._("No file available")."</td>\n");
    }
    print (" </tr>\n");
    print (" <tr><td bgcolor=white colspan=2>\n");
    print ("   <p align=right><a href=\"main.php?plugin=$plugin&sort=receiver_id&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("Back")."</a></td></tr>\n");
    print ("</table>\n");
    exit;
  }
}

if ($prtmode){
	print ("<h1>"._("FAX report - summary")."</h1>\n");
	print ("<div align=right><b><a align=right href=\"main.php?plugin=$plugin&sort=$sort&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("Back to main view <")."</a></b></div>\n");
}
else {
	print ("<div align=right><b><a href=\"main.php?plugin=$plugin&sort=$sort&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department&prtmode=1\">"._("> Printer friendly view")."</a></b></div>\n");

	print ("<form action=main.php?plugin=$plugin&sort=$sort method=\"post\">");
	print ("<table width=70%>\n");
	print (" <tr>\n");
	print ("  <td>"._("Department/User").":</td>\n");
	print ("  <td><select size=\"1\" name=\"department\">\n");
	for ($i=0; $i<count($deplist); $i++){
	  print ("<option");
	  if ($department==$deplist[$i]) print (" selected");
	  print (">$deplist[$i]</option>");
	}
	print ("  </select></td>\n");
	print ("  <td><select size=\"1\" name=\"fuser\">\n");
	for ($i=0; $i<count($usrlist); $i++){
	  print ("<option");
	  if ($fuser==$usrlist[$i]) print (" selected");
	  print (">$usrlist[$i]</option>");
	}
	print ("  </select></td>\n");
	print ("  <td></td>");
	print (" </tr>\n");
	print (" <tr>\n");
	print ("  <td>"._("Date start/end").":</td>\n");
	print ("  <td><input type=\"text\" size=\"20\" maxlength=\"10\" name=\"datefrom\" value=\"$datefrom\"></td>\n");
	print ("  <td><input type=\"text\" size=\"20\" maxlength=\"10\" name=\"dateto\" value=\"$dateto\"></td>\n");
	print ("  <td></td>");
	print (" </tr>\n");
	print (" <tr>\n");
	print ("  <td>"._("Time start/end").":</td>\n");
	print ("  <td><input type=\"text\" size=\"20\" maxlength=\"8\" name=\"timefrom\" value=\"$timefrom\"></td>\n");
	print ("  <td><input type=\"text\" size=\"20\" maxlength=\"8\" name=\"timeto\" value=\"$timeto\"></td>\n");
	print ("  <td><input type=\"submit\" name=\"acc\" value=\""._("Apply")."\"></td>\n");
	print (" </tr>\n");
	print ("</table>\n");

	print ("<br>\n");
	print ("</form>\n");
}

// Performing SQL query
if ($fuser != _("all") ){
  $userquery="AND uid = '$fuser'";
} else {
  if ($department != _("all")) {
    $ulist= ldap_get_list ("(&(objectclass=gonicusAccount)(ou=$department))");
    if (count($ulist)){
      $userquery= "AND ( uid = '".$ulist[0]["uid"][0]."' ";
      for ($j= 1; $j<$ulist["count"]; $j++)
        $userquery= $userquery." OR uid = '".$ulist[$j]["uid"][0]."'";
      $userquery= $userquery." ) ";
    }
  } else $userquery= "";
}

$query = "SELECT uid,queuing_time,status,sender_id,receiver_id,pages,id FROM faxlog WHERE queuing_time <= $now AND queuing_time >= $past $userquery ORDER BY $sort";
$result = mysql_query($query)
    or die("Database query failed!");

// Printing results in HTML
if ($prtmode){
	print "<table border=1 cellspacing=0 width=100%>\n";
}else{
	print "<table cellspacing=0 width=100%>\n";
}
print " <tr bgcolor=\"#BBBBBB\">";
print "  <td><b><a href=\"main.php?plugin=$plugin&sort=uid&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("User")."</a></b></td>
         <td><b><a href=\"main.php?plugin=$plugin&sort=queuing_time&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("Date")."</a></b></td>
         <td><b><a href=\"main.php?plugin=$plugin&sort=status&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("Status")."</a></b></td>
         <td><b><a href=\"main.php?plugin=$plugin&sort=sender_id&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("Sender")."</a></b></td>
         <td><b><a href=\"main.php?plugin=$plugin&sort=receiver_id&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("Receiver")."</a></b></td>
         <td><b><a href=\"main.php?plugin=$plugin&sort=pages&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department\">"._("# pages")."</a></b></td>";
print " </tr>";
$lc=0;
while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
    $id= $line["id"];
    if ($oldid==$id){
      $lc--;
    }
    else $oldid=$id;
    $color= ($lc++&1)?"#E0E0E0":"#F0F0F0";
    print "\n<tr bgcolor=$color>\n";
    $n=0;
    foreach ($line as $col_value) {
        switch ($n){
          case 0:
            print "<td><a href=\"main.php?plugin=$plugin&sort=pages&datefrom=$datefrom&dateto=$dateto&timefrom=$timefrom&timeto=$timeto&fuser=$fuser&department=$department&show_details=$id\">$col_value</a></td>";
            break;
          case 1:
            $day=substr($col_value, 6, 2);
            $month=substr($col_value, 4, 2);
            $year=substr($col_value, 0, 4);
            $hour=substr($col_value, 8, 2);
            $minute=substr($col_value, 10, 2);
            print "<td>$day.$month.$year $hour:$minute</td>\n";
            break;
          case 2:
            print "<td>$status[$col_value]</td>\n"; 
            break;
          case 6:
            break;
          default:
            print "<td>$col_value</td>\n";
            break;
        }
        $n++;
    }
    print "\n</tr>\n";
}
print "</table>\n";

// Free resultset
mysql_free_result($result);

// Closing connection
mysql_close($link);
?>


