<?PHP
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/


function getSortedDirs($sPath)
{
	$retVal= array();

	# Load Directory Into Array
	$handle=opendir($sPath);
	while ($file = readdir($handle)){
		if (is_dir($file)) $retVal[count($retVal)] = $file;
	}

	# Clean up and sort
	closedir($handle); 
	sort($retVal);

	return ($retVal);
}
	  


##
## Recursive function to find all plugins
##
function check_for_plugin ($dir, $flag=true){
	global $isadmin;
	global $isdepartmentadmin;
	static $level=-1;
	global $colcount;

	# abort when structure is to deep or junk directories are given
	if( $dir == "." || $dir == ".." ) return;

	# save the path for recursion
	$realdir= chop(`pwd`);

	$level++;
	if ($level>2){
		$level--;
		return;
	}
	chdir ($dir);
	$entryname= $flag?"entry.php":"bigentry.php";
	if (file_exists ($entryname)){
		if (!$flag && $colcount == 0){
			print (" <tr>\n");
		}
		include ($entryname);
		$colcount++;
		if (!$flag && $colcount > 3){
			$colcount= 1;
			print (" </tr>\n");
		}
	}
  	$file_list= getSortedDirs('.');

	# Search for possible plugins
	for ($i=0; $i < count($file_list); $i++){
		check_for_plugin ($file_list[$i], $flag);
	}
	$level--;

	chdir ($realdir);
}


##
## Menu generator
##
function generate_menu(){
	global $side_menu;

	if (!count($side_menu)){
		# Check for plugin directory
		if (!is_dir ("plugins")){
			echo "Fehler: Es wurde unterhalb von ";
			echo `pwd`;
			echo " kein plugin-Verzeichnis gefunden.\n<BR>";
			exit ();
		}
	
		# Search for possible plugins
		check_for_plugin ( chop (`pwd`)."/plugins");
		session_register ("side_menu");
	}
	else {
		for ($n= 0; $n<count($side_menu); $n++){
			echo $side_menu[$n];
		}
	}
}


##
## Generate Bigentry
##
function gen_bigentry($image,$text,$link){
	global $parent_length;

	$replace= $text;
	if (strlen ($image)){
		$rel_link= substr ($link, $parent_length);
		print ("<td><a href=main.php?plugin=$rel_link><img align=\"center\" src=\"$image\" width=48 height=48\n");
		print ("     border=0>&nbsp;&nbsp;$replace</a>\n  </td>\n");
	}
	else {
		print ("<tr><td colspan=3><hr><h2>$replace</h2></td><tr>\n");
	}
}


##
## Generate Menu entry
##
function register_plugin($name,$level,$link=""){
	global $parent_length, $plugin;
	global $side_menu;
	$text= $name;

	if ($link){
		$rel_link= substr ($link, $parent_length);
		$replace= "<a href=main.php?plugin=$rel_link>$text</a>\n";
	}else{
		$replace= $text;
	}

	if ($level == 1){
		$side_menu[]="<br><br>\n<table width=100% bgcolor=#CDF6BD>\n";
		print ("<br><br>\n<table width=100% bgcolor=#CDF6BD>\n");
		$side_menu[]=" <tr>\n  <td><center class=\"titlebar\">";
		print (" <tr>\n  <td><center class=\"titlebar\">");
		$side_menu[]="<font color=\"#00348B\">";
		print ("<font color=\"#00348B\">");
		$side_menu[]="<B>$replace</a></B></font></center>";
		print ("<B>$replace</a></B></font></center>");
		$side_menu[]="</td>\n </tr>\n</table>";
		print ("</td>\n </tr>\n</table>");
	}
	else {
		$side_menu[]="<table width=100% cellpadding=0 cellspacing=0 border=0><tr><td align=right>";
		print ("<table width=100% cellpadding=0 cellspacing=0 border=0><tr><td align=right>");
		$side_menu[]="<A class=menus>$replace</A>&nbsp;&nbsp;</td></tr></table>";
		print ("<A class=menus>$replace</A>&nbsp;&nbsp;</td></tr></table>");
	}
}

?>
