<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/

session_start ();
error_reporting (0);
require ("include/setup.inc");
require ("include/common.inc");
require ("include/ldap.inc");

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

# Setup language and text domain
$language=trim(get_language ($HTTP_ACCEPT_LANGUAGE));
putenv ("LANG=$language");
setlocale("LC_ALL", "");
bindTextDomain('main', './locale');
textDomain('main');

# rudimentary browser check
$compatible= false;
if (stristr ("$HTTP_USER_AGENT", "MSIE")) {
	$compatible= true;
}
if (stristr ("$HTTP_USER_AGENT", "Gecko")) {
	$compatible= true;
}
if (stristr ("$HTTP_USER_AGENT", "Opera")) {
	$compatible= true;
}
if (stristr ("$HTTP_USER_AGENT", "Konqueror")) {
	$compatible= true;
}
if (isset($override)){
	session_register ("override");
}
if (!$compatible && !isset($override)) {
	print (_("<b>Warning:</b> The webbrowser you're using is not tested").
		_(" for use with GOsa. Please use Mozilla, Netscape >= 6, MSIE").
		_(" Konqueror or Opera to administrate your server.")."<br><br>\n");
	print (_("If you want to continue anyway, follow ").
		"<a href=\"index.php?override=1\">"._("this link")."</a>.".
		"<br><br><br>\n");
	print (_("Your GONICUS team.\n"));
	exit ();
}

$admin_base= dirname($HTTP_SERVER_VARS['PHP_SELF']);
$admin_base="http://".$HTTP_SERVER_VARS['HTTP_HOST'].$admin_base;
$failed= false;

if (strlen($username)){
	# Check login, register session and open main.php
	$user_list= ldap_get_user_list ($username);

	if ($user_list["count"] == 1) {
		# try to bind
		$user= $user_list[0]["dn"];

		if (ldap_check_auth ($user,$password)) {
	
			# register session (user, password, etc.)
			session_register ("user");
			session_register ("username");
			session_register ("password");
			session_register ("admin_base");

			header("Location: $admin_base/main.php");
		} else {
			$failed= true;
	        }

	} else {
		$failed= true;
        }
}

# Page header
print (" <link rel=\"stylesheet\" href=\"include/style.css\" type=\"text/css\">\n");
print ("<body style=\"background:#8B898B\">\n");
print (" <form action=\"".basename($PHP_SELF)."\" method=\"post\">\n");
print ("<br><br>");
# Table
print ("  <table width=577 height=390 align=center cellspacing=0 cellpadding=0 border=0 background=\"images/login.png\">\n");
print ("   <tr align=\"left\" valign=\"top\">\n");
print ("    <td width=96 height=25>\n");
print ("    </td>\n");
print ("    <td width=422>\n");
print ("    </td>\n");
print ("    <td width=39>\n");
print ("    </td>\n");
print ("   </tr>\n");
print ("   <tr align=\"left\" valign=\"top\">\n");
print ("    <td heigth=290>\n");
print ("    </td>\n");
print ("    <td bgcolor=\"white\">\n");
print ("     <h1>"._("Welcome to the GONICUS System Administrator!")."</h1>");
print ("     "._("This frontend will assist you in managing your server systems, or\n"));
print ("     "._("will provide useful informations for common users.\n"));
print ("     <br><br>");
print ("     "._("Fill the <b>username</b> and <b>password</b> fields with your account\n"));
print ("     "._("information and press the <b>login</b> button to proceed.\n"));
print ("     <br><br>\n");
print ("     <table align=center>\n");
print ("      <tr>\n");
print ("       <td>\n");
print ("        <b>"._("Username")."</b>\n");
print ("       </td>\n");
print ("       <td>\n");
print ("        <input type=\"text\" name=\"username\" size=30 maxlength=40>\n");
print ("       </td>\n");
print ("      </tr>\n");
print ("      <tr>\n");
print ("       <td>\n");
print ("        <b>"._("Password")."</b>\n");
print ("       </td>\n");
print ("       <td>\n");
print ("        <input type=\"password\" name=\"password\" size=30 maxlength=40>\n");
print ("       </td>\n");
print ("      </tr>\n");
print ("      <tr>\n");
print ("       <td>\n");
print ("        <b>"._("Domain")."</b>\n");
print ("       </td>\n");
print ("       <td>\n");
print ("        <select name=\"domselect\">\n");

for ($i= 0; $i<count($DOMAIN_LIST); $i++) {
	print ("         <option>$DOMAIN_LIST[$i]</option>\n");
}

print ("        </select>\n         &nbsp;\n");
print ("        <input type=\"submit\" name=\"login\" value=\""._("Login")."\">\n");
print ("        &nbsp;\n");
print ("        <input type=\"reset\" name=\"reset\" value=\""._("Reset")."\">\n");
print ("       </td>\n");
print ("      </tr>\n");

if ($failed) {
	print ("      <tr>\n");
	print ("       <td colspan=2>\n");
	print ("       <br><br>\n");
	print ("       <font color=#FF0000><b>"._("Error: Login failed, check username/password combination!")."</b></font>\n");
	print ("      </td>\n");
	print ("     </tr>\n");
}

print ("     </table>\n");
print ("    </td>\n");
print ("    <td>\n");
print ("    </td>\n");
print ("   </tr>\n");
print ("   <tr align=\"left\" valign=\"top\">\n");
print ("    <td width=96 height=75>\n");
print ("    </td>\n");
print ("    <td>\n");
print ("    </td>\n");
print ("    <td>\n");
print ("    </td>\n");
print ("   </tr>\n");
print ("  </table>\n");
print (" </form>\n");
print ("</body>");

exit();
?>
