<?php 

# print error message
function display_error($message) {
	echo "<H2 align=center><B>$message</B></H2>\n";
	exit;
}


# assemble searchfilter
function create_searchfilter($criteria) {
	$fields = 0;

	// nur personen abfragen
	$filter = "(objectclass=" . $criteria["objectclass"] .")";
	++$fields;

	if ($criteria["uid"]) {
		$filter = $filter . "(uid=" . $criteria["uid"] . ")";
		++$fields;
	}
	if ($criteria["cn"]) {
		$filter = $filter . "(cn=*" . $criteria["cn"] . "*)";
		++$fields;
	}
	if ($criteria["telephonenumber"]) {
		$filter = $filter . "(telephonenumber=*" . $criteria["telephonenumber"] . "*)";
		++$fields;
	}
	if ($criteria["mobile"]) {
		$filter = $filter . "(l=" . $criteria["mobile"] . ")";
		++$fields;
	}
	if ($criteria["sn"]) {
		$filter = $filter . "(sn=*" . $criteria["sn"] . "*)";
		++$fields;
	}
	if ($criteria["givenname"]) {
		$filter = $filter . "(givenname=*" . $criteria["givenname"] . "*)";
		++$fields;
	}
	if ($fields >= 2) {
		$filter = "(&" . $filter . ")";
	}

	return $filter;
}


# read ldap entries
function search_dir($li, $filter) {
	global $LDAP_BASE;

	$sr = ldap_search($li, "$LDAP_BASE", $filter);
	if (ldap_count_entries($li, $sr) <= 0) {
		return 0;
	} else {
		$r = ldap_get_entries($li, $sr);
		return $r;
	}
}


# sort case insensitive
function ci_sort($a, $b) {
	return(strcmp(strtolower($a), strtolower($b)));
}


# sort entries for special attribute
function sort_results($array, $tag) {
	for ($i = 0; $i < count($array); $i++) {
		$tmp         = $array[$i][$tag][0] . $array[$i]["uid"][0];
		$help1[$i]   = $tmp;
		$help2[$tmp] = $i;
	}
	usort ($help1, ci_sort); 
	for ($i = 0 ; $i < count($help1); $i++) {
		$temp[$i] = $array[$help2[$help1[$i]]];
	}

	return $temp;
}


# print LDAP values
function print_results($results) {
	print ("<HR>\n");
	print ("<TABLE cellspacing=0 cellpadding=6 width=100% bgcolor=#B4D2DE>\n");
	print ("<TR BGCOLOR=#E0E0E0><font color=#00348B>\n");
	print ("<TD><B>"._("Name")."</B></TD>\n");
	print ("<TD><B>"._("Location")."</B></TD>\n");
	print ("<TD><B>"._("Phone")."</B></TD>\n");
	print ("<TD><B>"._("Mobile")."</B></TD>\n");
	print ("<TD><B>"._("Private")."</B></TD>\n");
	print ("<TD><B>"._("Fax")."</B></TD>\n");
	print ("<TD><B>"._("User ID")."</B></TD>\n");
	print ("<TD><B>"._("Organization")."</B></TD></font></TR>\n");

	$c= 0;
	for ($i = 1; $i < count($results); $i++) {
		if (!strlen ($results[$i]["telephonenumber"][0]) &&
			!strlen ($results[$i]["mobile"][0]) &&
			!strlen ($results[$i]["homephone"][0]) &&
			!strlen ($results[$i]["facsimiletelephonenumber"][0]) ){
			continue;
		}

		$c++;
		if ( $c & 1)  {
			print ("<TR BGCOLOR=#F0F0F0>\n");
		}
		else {
			echo "<TR BGCOLOR=#EAEAEA>"; 
		}

		printf ("<TD>%s, %s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD></TR>\n",
	                $results[$i]["sn"][0],
	                $results[$i]["givenname"][0],
			$results[$i]["l"][0],
	                $results[$i]["telephonenumber"][0],
	                $results[$i]["mobile"][0],
			$results[$i]["homephone"][0],
			$results[$i]["facsimiletelephonenumber"][0],
	                $results[$i]["uid"][0],
	                $results[$i]["ou"][0]);
   }

   print ("</TABLE>\n");
   print ("<HR>\n");
}

?> 
