<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/
$my= ldap_get_user_list ($username);

# check for objectclass qmailUser
$found= false;
for ($i=0; $i<$my[0]["objectclass"]["count"]; $i++){
	if ($my[0]["objectclass"][$i] == "qmailUser"){
		$found=true;
		break;
	}
}
if (!$found){
	print_red (_("Your account is not configured as a mail account."));
	exit ();
}

if (!($ldap=ldap_con ($user, $password))) exit;

if ($clear || $set || $add || $del ){
	# adapt delivery mode
	$deliveryMode= "normal";
	if ($delivery==1) $deliveryMode= "localdelivery";
	if ($reply==1) $deliveryMode= "reply";
	if ($delivery==1 && $reply==1){
		if ($add || $del) $deliveryMode= "localdelivery";
		else $deliveryMode= "reply";
	}

	# deliveryMode schreiben
	$entry= array();
	$entry["deliverymode"] = $deliveryMode; 
	if (!ldap_modify($ldap, $user, $entry)){
		print_red (_("Can't write LDAP entry on your request").": ".
                        ldap_error ($ldap));
		exit ();
	}
}

# Set or Clear button pressed
if ($clear || $set){
	# check reply text
        if (is_valid_input($replytext)){
		if ($set) $mailReplyText="$replytext";
		if ($clear) $mailReplyText=" ";
	
		# Write
		$entry= array();
		$entry["mailreplytext"] = stripcslashes($mailReplyText); 
		if (!ldap_modify($ldap, $user, $entry)){
			print_red (_("Can't write LDAP entry on your request").": ".
				ldap_error ($ldap));
			exit ();
		}
	}
	else {
		print_red (_("There are illegal characters in the vacation message!"));
	}
}

# Add or Delete button pressed
if ($add || $del){
	# Eventuell einen hinzufgen
	if ($add && strlen($forwardline)){
		$expression = "^[._A-Za-z0-9-]+@[_A-Za-z0-9-]+(\.[A-Za-z0-9]+)(\.[A-Za-z0-9]+)*$";
		if(!ereg("$expression",$forwardline)){
			print_red (_("You've to enter a valid Email address to be appended to the list of forwarders."));
		}else{
			$entry= array();
			$entry["mailforwardingaddress"][]= "$forwardline"; 
			if (!ldap_mod_add($ldap, $user, $entry)){
				print_red (_("Can't write LDAP entry on your request").": ".
					ldap_error ($ldap));
				exit ();
			}
		}
	}
	$entry= array();
	if ($del && count($forwarder)){
		for ($i=0; $i<count($forwarder);$i++){
			$entry["mailforwardingaddress"][] = $forwarder[$i]; 
		}
		if (!ldap_mod_del($ldap, $user, $entry)){
				print_red (_("Can't delete LDAP entry on your request").": ".
					ldap_error ($ldap));
				exit ();
		}
	}
}

ldap_close ($ldap);

# reload list
$my= ldap_get_user_list ($username);

print ("<form action=main.php?plugin=$plugin method=\"post\">\n");
print ("<table width=100% bgcolor=#F0F0F0>\n");
print ("<tr>\n");
print ("  <td colspan=4>\n");
print ("    <b>"._("Presets")."</b><br><br>\n");
print (_("These values can only be changed by an administrator. If you encounter some false settings, don't hesitate to contact the responsible person."));
print ("    <br><br>\n");
print ("  </td>\n");
print ("</tr>\n");
print ("<tr>\n");
print ("  <td valign=top>\n");
print ("    <b>"._("Email").":</b><br>\n");
print ("    <b>"._("Size limit").":</b>\n");
print ("  </td>\n");
print ("  <td valign=top>\n");

echo get_entry ($my,"mail")."<br>";
$quota= split(",", get_entry ($my,"mailquota"));
$x=(float)$quota[0]/1000000;
if ($x == 0){
	print (_("none"));
}
else{
	print ("$x MB\n");
}

print ("  </td>\n");
print ("  <td valign=top>\n");
print ("    <b>"._("Alternate Emails").":</b>\n");
print ("  </td>\n");
print ("  <td>\n");

for ($i= 0; $i<$my[0]["mailalternateaddress"]["count"]; $i++){
	echo $my[0]["mailalternateaddress"][$i]."<br>";
}

print ("  </td>\n");
print ("</tr>\n");
print ("</table>\n");
print ("<br>\n");

print ("<table cellpadding=5 cellspacing=0 width=100% bgcolor=#F0F0F0>\n");
print ("<tr>\n");
print ("  <td colspan=2>\n");
print ("    <b>"._("Personal settings")."</b><br><br>\n");
print (_("These values can be changed at any time and are mainly meant to change the vacation message and adjust some forwarding policies. Note that vacation messages and forwardings can't be enabled at the same time."));
print ("    <br>\n");
print ("  </td>\n");
print (" </tr>\n");
print (" <tr>\n");
print ("  <td valign=top>\n");
print ("    <b>"._("Message forwarding")."</b>\n");
print ("  </td>\n");
print ("  <td>\n");
print ("    <input type=\"checkbox\" name=\"delivery\" value=\"1\"\n");

if( get_entry ($my, "deliverymode") == "localdelivery"){
	echo " checked ";
}
print (">\n");

print (_("keep local copy")."<br>");
print ("    <select style=\"width:80%\" name=\"forwarder[]\" size=\"7\" multiple>\n");

for ($i=0; $i<$my[0]["mailforwardingaddress"]["count"]; $i++){
	echo "<option>".$my[0]["mailforwardingaddress"][$i]."</option>";
}

print ("    </select>\n");
print ("  </td>\n");
print (" </tr>\n");
print (" <tr>\n");
print ("  <td></td>\n");
print ("  <td>\n");
print ("    <input name=\"forwardline\" type=\"text\" size=\"45\" maxlength=\"80\">&nbsp;\n");
print ("    <input type=\"submit\" name=\"add\" value=\""._("Add")."\">&nbsp;\n");
print ("    <input type=\"submit\" name=\"del\" value=\""._("Delete")."\">\n");
print ("  </td>\n");
print (" </tr>\n");
print (" <tr>\n");
print ("  <td valign=top><b>"._("Vacation message")."</b><br></td>\n");
print ("  <td>\n");
print ("    <input type=\"checkbox\" name=\"reply\" value=\"1\"\n");

if( get_entry ($my, "deliverymode") == "reply"){
	echo " checked ";
}
print (">\n");
print (_("activate vacation message")."<br>\n");

if (!strlen($replytext)){
	$replytext= get_entry ($my, "mailreplytext");
}
print ("    <textarea style=\"width:80%\" name=\"replytext\" cols=\"60\" rows=\"5\" wrap=\"soft\">".stripcslashes($replytext)."</textarea>\n");
print ("  </td>\n");
print (" </tr>\n");
print (" <tr>\n");
print ("  <td></td>\n");
print ("  <td>\n");
print ("    <input type=submit name=\"set\" value=\""._("Apply")."\">&nbsp\n");
print ("    <input type=submit name=\"clear\" value=\""._("Delete")."\">\n");
print ("  </td>\n");
print (" </tr>\n");
print ("</table>\n");

print ("<table width=100% bgcolor=#F0F0F0><tr><td align=right>\n");
print ("<br><br><input type=submit name=\"set\" value=\""._("Apply")."\">&nbsp\n");
print ("</td></tr></table>\n");
print ("</form>\n");

?>
