<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/

if (!isset($sorting)) $sorting= 0;
if ($abort){
	session_unregister ("grouplist");
	session_unregister ("newuser");
}

# wanna delete groups?
if ($delete && $grouplist){

	print ("	<form action=main.php?plugin=$plugin method=\"post\">\n");
	print ("	<b>"._("Confirm group deletion")."</b><br><br>\n");
	print (_("You've selected the following groups for deletion. These entries will be delete from your LDAP database. Notice that you can also delete primary user groups. The corresponding user will not be deleted. Please confirm this action."));
	print ("<br><br>\n");

	# store userlist for users to be deleted
	session_register ("grouplist");

	for ($i=0; $i<count($grouplist); $i++){
		echo $grouplist[$i]."<br>";
	}

	print ("<br>\n");
	print (_("Should these groups be deleted?"));
	print ("<br><br>\n");
	print ("	<input type=submit value=\""._("Delete")."\" name=\"confirm\">&nbsp;\n");
	print ("	<input type=submit value=\""._("Abort")."\" name=\"abort\">&nbsp;\n");
	print ("	</form>\n");

	exit();
}


# really delete groups
if ($confirm){
	if (!($ldap=ldap_con ($user, $password))){
		print_red (_("Can't delete entry: ").ldap_error($ldap));
		exit ();
	}

	for ($i=0; $i<count($grouplist); $i++){
		for ($j= 0; $j<$groups["count"]; $j++){
			$thegroup= split ("\(", $grouplist[$i]);
			if ($groups[$j]["cn"][0] == chop($thegroup[0])){
				$groupdn= $groups[$j]["dn"];
				if (! ldap_delete ($ldap, $groupdn)){
					print_red (_("Can't delete group").
						" $groupdn: ".ldap_error($ldap));
				}
				break;
			}
		}
	}
	ldap_close ($ldap);
}


# Check and modify
if ($modify){
	$cn= $HTTP_POST_VARS["cn"];
	$dn= "cn=$cn,".$HTTP_POST_VARS["dnfield"];
	$description= $HTTP_POST_VARS["description"];

	# group exists?
	if ($newuser){
		$userexists= false;
		for ($i= 0; $i<$groups["count"]; $i++){
			if ($groups[$i]["cn"][0]==$cn){
				$userexists= true;
				break;
			}
		}
	}

	# check fields
	if (!$HTTP_POST_VARS["cn"]){
		print_red (_("Missing data: At least fill the fields marked with *!"));
		$moreselect= true;

		session_register ("dn");
		session_register ("cn");
		session_register ("description");
	}elseif (!ereg("^[.a-z0-9]*$", $cn)){
		print_red (_("The field -Name- should only contain lowercase letters or numbers."));
		$moreselect= true;
	}elseif (!is_valid_input ($description)){
		print_red (_("The field -Description- contains illegal characters!"));
		$moreselect= true;
	}elseif ($userexists){
		print (_("You're trying to create a group that already exists. Choose another name."));
		$moreselect= true;
	}else{
		# Connect to LDAP
		if (!($ldap= ldap_con ($user, $password))){
			print_red (_("Can't connect to LDAP: ").ldap_error($ldap));
			exit ();
		}

		$entry= array();
		$entry["objectClass"][]="posixGroup";
		$entry["cn"]= $cn;
		if ($gidNumber == 0)
			$entry["gidNumber"]= get_next_gid($groups);
		else
			$entry["gidNumber"]= $gidNumber;
		
		if ($description) $entry["description"][]= $description;
		
		for ($g= 0; $g<count($groupmembers); $g++){
			$thegroup= split ("\(",$groupmembers[$g]);
			$thegroup= split ("\)",$thegroup[1]);
			$entry["memberUid"][]= $thegroup[0];
		}
		if (!$newuser){
			ldap_delete ($ldap, $old_dn);
		}
		if (!ldap_add ($ldap, $dn, $entry)){
			print_red (_("Can't add entry: ").
				ldap_error($ldap));
			exit ();
		}
		ldap_close ($ldap);
	}
}


# remove user from group
if ($deluser){
	$newlist= array();
	for ($j= 0; $j<count($groupmembers); $j++){
		for ($i= 0; $i<count($groupselect); $i++){
			if ($groupmembers[$j]==$groupselect[$i]) break;
		}
		if ($i == count($groupselect)){
			$newlist[]= $groupmembers[$j];
		}
	}
	$groupmembers= $newlist;
	for ($i= 0; $i<count($groupselect); $i++) $userlist[]= $groupselect[$i];
	$cn= $HTTP_POST_VARS["cn"];
	$description= $HTTP_POST_VARS["description"];
	$dn= $HTTP_POST_VARS["dnfield"];
	session_register ("groupmembers");
	session_register ("userlist");
	session_register ("cn");
	session_register ("dn");
	session_register ("description");
}


# add user to group
if ($adduser){
	$newlist= array();
        for ($j= 0; $j<count($userlist); $j++){
		$found= false;
                for ($i= 0; $i<count($userselect); $i++){
                        if ($userlist[$j]==$userselect[$i]){
				$found= true;
				break;
			}
                }
                if (!$found) $newlist[]= $userlist[$j];
        }
        $userlist= $newlist;
        for ($i= 0; $i<count($userselect); $i++) $groupmembers[]= $userselect[$i];	
	$cn= $HTTP_POST_VARS["cn"];
	$description= $HTTP_POST_VARS["description"];
	$dn= "cn=$cn,".$HTTP_POST_VARS["dnfield"];
	session_register ("groupmembers");
	session_register ("userlist");
	session_register ("cn");
	session_register ("dn");
	session_register ("description");
}


# edit group
if ($new || $select || $adduser || $deluser || $moreselect){
	if ($new){
		$groupmembers= array ();
		$newuser= true;
		$gidNumber= 0;
		session_register ("newuser");
	}
	if ($select){
		# group dn
		$thegroup= split ("\(",$grouplist[0]);
		for ($i= 0; $i<$groups["count"]; $i++)
			if ($groups[$i]["cn"][0] == chop($thegroup[0])) break;
		if ($i == $groups["count"]){
			print_red (_("Internal Error: the group does not exist!"));
			exit ();
		}
		$cn= $groups[$i]["cn"][0];
		$description= $groups[$i]["description"][0];

		# prepare groupmembers
		$dn= $groups[$i]["dn"];
		$gidNumber= $groups[$i]["gidnumber"][0];
		$old_dn= $dn;
		if (!$adduser && !$deluser){
			$groupmembers= array();
			for ($j= 0; $j<$groups[$i]["memberuid"]["count"]; $j++){
				$ucn= "";
				for ($k= 0; $k<$users["count"]; $k++){
					if ($users[$k]["uid"][0] == $groups[$i]["memberuid"][$j]){
						$ucn= $users[$k]["cn"][0];
						break;
					}
				}
				if ($ucn) $groupmembers[]= $ucn." (".$groups[$i]["memberuid"][$j].")";
				else $groupmembers[]= "(".$groups[$i]["memberuid"][$j].")";
			}
	
			$newlist= array();
			for ($k= 0; $k<count($userlist); $k++){
				for ($j= 0; $j<count($groupmembers); $j++){
					if ($groupmembers[$j]==$userlist[$k]) break;
				}
				if ($j == count($groupmembers))
					$newlist[]= $userlist[$k];
			}
			$userlist= $newlist;
		}
	}
	sort ($userlist);
	sort ($groupmembers);

	# show form
	session_register ("groupmembers");
	session_register ("grouplist");
	session_register ("gidNumber");
	session_register ("userlist");
	session_register ("cn");
	session_register ("dn");
	session_register ("old_dn");
	session_register ("description");
	include ($plugin."/include/groupedit.php");	
	exit;
}


##########################################
##                  Main                ##
##########################################

# prepare session
session_unregister ("grouplist");
session_unregister ("users");
session_unregister ("userlist");
session_unregister ("groups");
session_unregister ("groupmembers");
session_unregister ("grouplocations");
session_unregister ("gidNumber");
session_unregister ("dn");
session_unregister ("old_dn");
session_unregister ("cn");
session_unregister ("newuser");
session_unregister ("description");

# read lists
$users= ldap_get_user_list ();
$userlist= array();
for ($i= 0; $i<$users["count"]; $i++){
	$uname= $users[$i]["sn"][0].", ".$users[$i]["givenname"][0];
	if ($uname == ", "){
		$userlist[]= "(".$users[$i]["uid"][0].")";
	}
	else {
		$userlist[]= "$uname (".$users[$i]["uid"][0].")";
	}
}
sort ($userlist);

$groups= ldap_get_group_list ();
$grouplocations= ldap_get_list ("ou=Groups");

session_register ("users");
session_register ("userlist");
session_register ("grouplocations");
session_register ("groups");

# show form
include ($plugin."/include/mainform.inc");
?>


