<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/

if ($addlocals || $deluser || $adduser || $modify){
	$mail= $HTTP_POST_VARS["mail"];
	$dn= $HTTP_POST_VARS["dn"];
	$uid= $HTTP_POST_VARS["uid"];
}

if ($modify){
	$notcomplete= false;
	if (!is_email_address ($mail)){
		print_red (_("The email address you're trying to add is not valid or empty!"));
		$notcomplete= true;
	}

	if ($newuser && !$notcomplete){
		# suchen in mail und mailalternateaddress
		$found= false;
		for ($i=0; $i<$allusers["count"]; $i++){
			if ($allusers[$i]["mail"][0] == $mail){
				$found= true;
				break;
			}
			for ($j= 0; $j<$allusers[$i]["mailalternateaddress"]["count"]; $j++){
				if ($allusers[$i]["mailalternateaddress"][$j] == $mail ){
					$found= true;
					break;
				}
			}
			if ($found) break;
		}

		if ($found){
			print_red (_("The e-mail address you're trying to use for the list is allready in use!"));
			$notcomplete= true;
		}
		
		# suchen in allen uids
		$found= false;
		for ($i= 0; $i<$allusers["count"]; $i++){
			if ($allusers[$i]["uid"][0] == $uid){
				$found= true;
				break;
			}
		}

		if ($found){
			print_red (_("The list name you're using is allready in use. Please choose another one."));
			$notcomplete= true;
		}
	}

	if ((!ereg("^[.a-z0-9]*$", $uid) || !$uid) && !$notcomplete){
		print_red (_("The list name you've specified contains invalid characters or is not set."));
		$notcomplete= true;
	}

	if ((!count ($listmembers)) && !$notcomplete){
		print_red (_("The mailinglist should have at least one member."));
		$notcomplete= true;
	}

	if (!$notcomplete){
		if (!($ldap=ldap_con ($user, $password))){
	                print_red (_("Can't connect to the LDAP server: ").ldap_error($ldap));
			exit ();
		}

		$entry= array();
		$dn="uid=$uid,$dn";
		$entry["objectclass"][]= "inetOrgPerson";
		$entry["objectclass"][]= "organizationalPerson";
		$entry["objectclass"][]= "qmailUser";
		$entry["objectclass"][]= "mailingList";
		$entry["uid"][]= $uid;
		$entry["givenName"][]= "$uid";
		$entry["sn"][]= "Mailingiste";
		$entry["cn"][]= "Mailingliste $uid";
		$entry["mail"][]= $mail;
		$entry["deliverymode"][]= "forwardonly";
		if (isset($QMAIL_HOSTS)){
			$entry["mailhost"][]=$QMAIL_HOSTS[0];
		}

		for ($i= 0; $i<count($listmembers); $i++){
			$entry["mailForwardingAddress"][]= $listmembers[$i];
		}
		if (!$newuser){
			if (!ldap_delete ($ldap, $old_dn)){
				print_red (_("Can't delete entry: ").ldap_error());
				exit();
			}
		}

                if (!ldap_add ($ldap, $dn, $entry)){
			print_red (_("Can't add entry: ").ldap_error($ldap));
                	exit ();
                }
		ldap_close ($ldap);
	}
}


if ($addlocals){
	for ($i= 0; $i<count($localusers); $i++)
		$listmembers[]= $localusers[$i];
		
	sort ($listmembers);
	session_register ("listmembers");
}

if ($deluser){
	$newlist= array ();
	
	for ($j= 0; $j<count($listmembers); $j++){
		for ($i= 0; $i<count($selectlist); $i++){
			if ($listmembers[$j] == $selectlist[$i]) break;
		}
		if ($i == count($selectlist)) $newlist[]= $listmembers[$j];
	}
	$listmembers= $newlist;
	sort ($listmembers);
	session_register ("listmembers");
}

if ($adduser){
	if (!is_email_address ($userline)){
		print_red (_("The e-mail address you're trying to add is not valid! Please try again."));
	}
	else{
		$listmembers[]= $userline;
		sort ($listmembers);
		session_register ("listmembers");
	}
}

if ($new || ($select && count($maillist))){
	$dn= ""; 
	if ($new){
		$newuser= true;
		session_register ("newuser");
	}
	if ($select){
		# dn bestimmen
		$temp= split("\(", $maillist[0]);
		$mail= chop ($temp[0]);
		for ($i= 0; $i<$users["count"]; $i++){
			if ($users[$i]["mail"][0] == $mail){
				$dn= $users[$i]["dn"];
				$old_dn= $dn;
				session_register ("dn");
				session_register ("old_dn");
				break;
			}
		}
		$uid= $users[$i]["uid"][0];
		
		# Momentane Benutzerlisteliste erzeugen
		$listmembers= array ();
		for ($j= 0; $j<$users[$i]["mailforwardingaddress"]["count"]; $j++)
			$listmembers[]= $users[$i]["mailforwardingaddress"][$j];
		sort ($listmembers);
		session_register ("listmembers");

		if ($i == $users["count"]){
			print_red (_("There's no list with that name."));
			exit ();
		}
	}
}


if (($select && count($maillist)) || $adduser || $deluser || $addlocals || $new || $modify){
		$nolistmembers= array ();
		if (count($listmembers)){
			for ($j= 0; $j<$allusers["count"]; $j++){
				for ($k= 0; $k<count ($listmembers); $k++){
					if ($listmembers[$k] == $allusers[$j]["mail"][0]) break;
				}
				if ($k == count ($listmembers))
					$nolistmembers[]= $allusers[$j]["mail"][0];
			}
		}else{
			for ($j= 0; $j<$allusers["count"]; $j++)
				$nolistmembers[]= $allusers[$j]["mail"][0];
		}
		sort ($nolistmembers);
		session_register ($nolistmembers);
}


if ($new || ($select && count($maillist)) || $addlocals || $deluser || $adduser || $notcomplete){
	include ($plugin."/include/listedit.inc");
	exit ();
}

if ($delete && count($maillist)){
	# dn bestimmen
	$temp= split("\(", $maillist[0]);
	$mail= chop ($temp[0]);
	for ($i= 0; $i<$users["count"]; $i++){
		if ($users[$i]["mail"][0] == $mail){
			$dn= $users[$i]["dn"];
			session_register ("dn");
			break;
		}
	}

	print ("        <form action=main.php?plugin=$plugin method=\"post\">\n");
	print ("        <b>"._("Confirm deletion of mailinglists")."</b><br>\n");
	print ("        <br>\n");
	print (_("You've selected the folowing lists for deletion. The corresponding entries will be deleted instantly. Please confirm this action."));
	print ("        <br><br>\n");

        # store userlist for users to be deleted
        session_register ("grouplist");

        for ($i=0; $i<count($maillist); $i++){
                echo $maillist[$i]."<br>";
	}
        print ("        <br>\n");
	print (_("Should this lists be deleted?"));
	print ("        <br><br>\n");
	print ("        <input type=submit value=\""._("Delete")."\" name=\"perform_delete\">&nbsp;\n");
	print ("        <input type=submit value=\""._("Abort")."\" name=\"abort\">&nbsp;\n");
	print ("        </form>\n");

        exit();		
}

if ($perform_delete){
	if (!($ldap=ldap_con ($user, $password))){
		print_red (_("Can't connect to LDAP: ").ldap_error());
		exit ();
	}
	
	if (!ldap_delete ($ldap, $dn)){
		print_red (_("Can't delete entry: ").ldap_error());
		exit ();
	}

	ldap_close ($ldap);
}



##########################################
##                  Main                ##
##########################################

# Session-Variablen lschen
session_unregister ("users");
session_unregister ("userlist");
session_unregister ("allusers");
session_unregister ("uid");
session_unregister ("mail");
session_unregister ("listmembers");
session_unregister ("nolistmembers");
session_unregister ("listlocations");
session_unregister ("dn");
session_unregister ("old_dn");
session_unregister ("newuser");

# Benutzerliste einlesen
$users= ldap_get_list ("objectclass=mailingList");
$userlist= array();
for ($i= 0; $i<$users["count"]; $i++){
	$userlist[]= $users[$i]["mail"][0]." (".$users[$i]["uid"][0].")";
}
sort ($userlist);

$allusers= ldap_get_list ("objectclass=qmailUser");

$listlocations= ldap_get_list ("ou=People");

session_register ("users");
session_register ("userlist");
session_register ("allusers");
session_register ("listlocations");

# Hauptformular darstellen
include ($plugin."/include/mainform.inc");
?>


