<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/

$attriblist= array ("cn", "syslogserver", "ntpserver", "swapserver", "lpdserver", "fontpath", "filesystem", "scannerclients", "terminal", "rootpasswd", "sndmodule", "lastuser", "xmonitor", "xcolordepth", "xmousebuttons", "xkbmodel", "xkbvariant", "macaddress", "gfxadapter", "netnic", "soundadapter", "idedev", "scsidev", "usbsupport", "memsize", "cputype" );

 $driverlist= array ("cirrus_laguna", "i810", "radeon", "tga", "cyrix", "rendition", "trident", "ati", "fbdev", "s3virge", "tseng", "glide", "mga", "savage", "vesa", "chips", "glint", "neomagic", "siliconmotion", "vga", "cirrus_alpine", "i128", "nv", "sis", "cirrus", "i740", "r128");
sort ($driverlist);

$reslist= array ("640x480", "800x600", "1024x768", "1152x864", "1280x1024", "1600x1200", "1600x1400");


# final delete
if ($confirm){
	if (!($ldap=ldap_con ($user, $password))){
		print_red (_("Can't delete terminal: ").": ".
			ldap_error ($ldap));
		exit ();
	}

	# delete all selected terminals
	for ($i=0; $i<count($selectlist); $i++){
		$pre= split ("\(", $selectlist[$i]);
		$fin= split ("\)",$pre[1]);

		for ($j=0; $j<$terminals["count"]; $j++){
			if ($terminals[$j]["cn"][0] == $fin[0])
				break;
		}
		
		if ($j == $terminals["count"]) break;

		# remove terminal entry
		if (! ldap_delete ($ldap, $terminals[$j]["dn"])){
			print_red ($terminals[$j]["dn"]._(" can't be deleted: ").
				ldap_error ($ldap));
			exit ();
		}
	}
}


if ($continue){
	if (!is_valid_input($xserver)){
		$continue= false;
		$select= true;
		$selectlist[0]= "dummy ($client)";
		print_red (_("The Server string contains illegal characters!"));
	}
}

# write entry
if ($continue){
	$entry= array ();

	$entry["objectclass"][]="GOtoTerminal";
	$entry["objectclass"][]="GOHard";
	for ($i= 0; $i<count($attriblist); $i++){
		$value= $terminals[$theone][$attriblist[$i]][0];
		if ($value){
			$entry[$attriblist[$i]][]=$value;
		}
	}

	$entry["floppyenable"][]= $floppy?"YES":"NO";
	$entry["cdromenable"][]= $cdrom?"YES":"NO";
	$entry["lpdenable"][]= $printer?"YES":"NO";
	$entry["scannerenable"][]= $scanner?"YES":"NO";

	if ($xserver) $entry["xdmcpserver"][]= $xserver;
	$isenabled= "true";
	if ($session==_("disabled")) $isenabled= "false";
	if ($session==_("normal")) $xmethod="query";
	if ($session==_("show chooser")) $xmethod="indirect";

	$entry["isenabled"][]= $isenabled;
	if ($xmethod) $entry["xmethod"][]= $xmethod;

	$entry["xdriver"][]= $xdriver;
	if ($xResolution != _("global")) $entry["xresolution"][]=$xResolution;

	$entry["xhsync"][]= $hSync;
	$entry["xvsync"][]= $vSync;

	if ($xMouseType == _("Serial mouse")){
		$entry["xmousetype"][]= "Microsoft";
		$entry["xmouseport"][]= "/dev/ttyS0";
	}
	if ($xMouseType == _("PS/2 mouse")){
		$entry["xmousetype"][]= "PS/2";
		$entry["xmouseport"][]= "/dev/psaux";
	}
	if ($xMouseType == _("Wheel mouse")){
		$entry["xmousetype"][]= "IMPS/2";
		$entry["xmouseport"][]= "/dev/psaux";
	}
	if ($xMouseType == _("autodetect")){
		$entry["xmousetype"][]= "auto";
		$entry["xmouseport"][]= "auto";
	}
	
	# xkblayout
	if ( $kbdLayout== _("german")) $entry["xkblayout"][]= "de";
	else $entry["xkblayout"]= "en";

	if (!($ldap=ldap_con ($user, $password))){
		print_red (_("Can't connect to LDAP server!"));
	}

	# erst lschen, dann anlegen
	ldap_delete ($ldap, $terminals[$theone]["dn"]);

	if (!ldap_add ($ldap, "cn=".$terminals[$theone]["macaddress"][0].",$dn", $entry)){
                print_red (_("Can't create entry for: ").ldap_error ($ldap));
                exit ();
        }	
}


# Ask for deletion
if ($delete && count ($selectlist)){
	print ("<form action=main.php?plugin=$plugin method=\"post\">\n");
        print ("<b>"._("Confirm the deletion of terminals")."</b><br>\n");
        print ("<br>\n");
	print (_("You've selected the following terminals for deletion. The corresponding LDAP entries will be lost. Please confirm this action."));
	print ("<br><br>\n");

        for ($i=0; $i<count($selectlist); $i++){
                echo $selectlist[$i]."<br>";
	}

        # store userlist for users to be deleted
        session_register ("selectlist");

	print ("<br>\n");
        print (_("Should these terminals be deleted?"));
        print ("<br>\n");
        print ("<input type=submit value=\""._("Delete")."\" name=\"confirm\">&nbsp;\n");
        print ("<input type=submit value=\""._("Abort")."\" name=\"abort\">&nbsp;\n");
        print ("</form>\n");

        exit();	
}


# Look for new terminals
if ($select && count ($selectlist)){
	$tmp= split ("\(", $selectlist[0]);
	$fake= split ( "\)", $tmp[1]);

	for ($i= 0; $i<$terminals["count"]; $i++){
		if ($terminals[$i]["macaddress"][0] == $fake[0])
			break;
	}
	
	if ($i == $terminals["count"]){
		print (_("Illegal selection!"));
	}

	$client= $fake[0];
	session_register ("client");

	# preset terminals-mode
	$mode= 1;
	if ($terminals[$i]["xmethod"][0]=="indirect") $mode= 2;
	if ($terminals[$i]["isenabled"][0]=="false") $mode= 0;

	$theone= $i;
	session_register ("theone");
	print_header (_("Step 1: Configuring terminal"));
	include ($plugin."/include/terminaledit.inc");
	exit ();
}


##########################################
##                  Main                ##
##########################################

# Delete session variables
session_unregister ("termlocations");
session_unregister ("terminals");
session_unregister ("selectlist");
session_unregister ("theone");
session_unregister ("client");

# Get userlist
$terminals= ldap_get_list ("objectclass=gototerminal");
$termlist= array();
for ($i= 0; $i<$terminals["count"]; $i++){
	if ($terminals[$i]["macaddress"][0]){
		$new=ereg("incoming",$terminals[$i]["dn"])?"&lt;neu&gt;":"";
		$termlist[]= "$new ".$terminals[$i]["terminal"][0]." (".$terminals[$i]["macaddress"][0].")";
	}
}
sort ($termlist);

$termlocations= ldap_get_list ("ou=terminals");

session_register ("terminals");
session_register ("termlocations");

# Show main form
include ($plugin."/include/mainform.inc");
?>


