<?php
/**************************************************************************
*                        GONICUS Server Administration                    *
*        Version 1.0.0  (C) 2002 Cajus Pollmeier <pollmeier@gonicus.de>   *
***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation, version 2 of the License                *
*                                                                         *
***************************************************************************/

if (!isset($sorting)){
	$sorting= 0;
}
if ($abort){
	session_unregister ("blocklist");
	session_unregister ("newlist");
}

# lschen besttigen
if ($confirm) {
	if (!($ldap=ldap_con ($user, $password))){
                print_red (_("Can't connect to LDAP server: ".ldap_error ($ldap)));
		exit ();
	}

	for ($i=0; $i<count($blocklist); $i++){
		$dn= "cn=$blocklist[$i],ou=gofax,$FAX_DN";
		if (! ldap_delete ($ldap, $dn)){
			print_red ( _("Entry ").$blocklist[$i]._(" could not be deleted: ").ldap_error ($ldap));
		}
	}
}

# write new entries
if ($modify) {
	$expression = "^[A-Za-z0-9_. -]+$";
	if (ereg("$expression",$fname)){
		if (!($ldap=ldap_con ($user, $password))){
                	print_red (_("Can't connect to LDAP server: ").ldap_error ($ldap));
			exit ();
		}
		if (strlen($oldname)){
			# At this time fix. Must be changed later on!
			$olddn= "cn=$oldname,ou=gofax,$FAX_DN";
			if (!ldap_delete ($ldap, $olddn)){
				print_red (_("Can't delete ")."$olddn: ".
					ldap_error ($ldap));
				exit ();
			}
		}

		$newdn= "cn=$fname,ou=gofax,$FAX_DN";
		$entry= array();
		$entry["objectClass"][]= "goFaxSBlock";
		$entry["cn"]= "$fname";
		for ($i=0; $i<count($numlist); $i++){
			$entry["goFaxSBlocklist"][]= "$numlist[$i]";
		}

		if (!ldap_add ($ldap, $newdn, $entry)){
			print_red (_("Can't create LDAP entry: ").
				ldap_error ($ldap));
			exit ();
		}

		ldap_close ($ldap);
	}
	else {
		print_red (_("The listname is not set or contains illegal characters!"));
		include ($plugin."/include/blocklist.php");
		exit;
	}
}

# new list
if ($new){
	$newlist= true;
	session_register ("newlist");
	$numlist= array();
	$name= "";
	include ($plugin."/include/blocklist.php");
	exit;
}

# Edit list
if (($select && $blocklist) || $addnumber || $delnumber){
	$newlist= false;
	session_register ("newlist");

	if ($addnumber) {
		if (is_telephone_number ($tnumber)){
			$numlist[]= $tnumber;
		}
		else {
			print_red (_("The specified phone number contains illegal characters!"));
		}
	}
	else if ($delnumber) {
		# numbers[] rauskopieren
		$tmp= array();
		if (count($numbers)){
			for ($j=0; $j<count($numlist); $j++){
				$found= false;
				for ($i=0; $i<count($numbers); $i++){
					if ($numlist[$j] == $numbers[$i]) $found= true;
				}
				if (!$found) {
					 $tmp[]= $numlist[$j];
				}
			}
			$numlist= $tmp;
		}
	}
	else {
		# Blockliste einlesen
		$fname= $blocklist[0];
		$oldname= $fname;
		$block= ldap_get_list ("(&(cn=$fname)(objectClass=goFaxSBlock))");
		$numlist= array();
		for ($i= 0; $i<$block["count"]; $i++){
			for ($j= 0; $j<$block[$i]["gofaxsblocklist"]["count"]; $j++){
				$numlist[]= $block[$i]["gofaxsblocklist"][$j];
			}
		}
		session_register ("oldname");
	}

	$name= $fname;
	sort ($numlist);
	session_register ("numlist");
	session_register ("name");
  
	include ($plugin."/include/blocklist.php");
	exit;
}

# Lschen von Listen - Nachfrage
if ($delete && $blocklist){
	print ("<form action=main.php?plugin=$plugin method=\"post\">\n");
        print ("<b>"._("Confirm deletion of blocklists")."</b><br>\n");
        print ("<br>\n");
        print (_("You've choosen the following blocklists for deletion. The corresponding database entries will be delete from your LDAP database. Please confirm this action."));
        print ("<br><br>\n");

        # store userlist for users to be deleted
        session_register ("blocklist");

        for ($i=0; $i<count($blocklist); $i++){
                echo $blocklist[$i]."<br>";
	}

        print ("<br>\n");
	print (_("Should the above blocklists be deleted?"));
	print ("<br><br>\n");
        print ("<input type=submit value=\""._("Delete")."\" name=\"confirm\">&nbsp;");
	print ("<input type=submit value=\""._("Abort")."\" name=\"abort\">&nbsp;");
	print ("</form>\n");

        exit();
}


##########################################
##                  Main                ##
##########################################

# Session-Variablen lschen
session_unregister ("blocklist");
session_unregister ("name");
session_unregister ("oldname");
session_unregister ("iblocklist");
session_unregister ("numlist");
session_unregister ("newlist");

# Blocklisten einlesen
$block= ldap_get_list ("(&(cn=*)(objectClass=goFaxSBlock))");
$iblocklist= array();
for ($i= 0; $i<$block["count"]; $i++){
  for ($j= 0; $j<$block[$i]["cn"]["count"]; $j++)
    $iblocklist[]= $block[$i]["cn"][$j];
}
sort ($iblocklist);
session_register ("iblocklist");

# Hauptformular darstellen
include ($plugin."/include/mainform.inc");
?>


